from . import schema_to_class as s2c
import json

def app( timestep, cases = 1 ):
    event = s2c.get_default_campaign_event()
    coordinator = s2c.get_class_with_defaults( "StandardEventCoordinator" )
    if coordinator is None:
        print( "s2c.get_class_with_defaults returned None. Maybe no schema.json was provided." )
        return ""
    coordinator.Max_Cases_Per_Node = cases
    event.Event_Coordinator_Config = coordinator
    intervention = s2c.get_class_with_defaults( "OutbreakIndividual" )
    coordinator.Intervention_Config = intervention
    event.Start_Day = float(timestep+1)

    coordinator.finalize()
    intervention.finalize()

    campaign = {}
    campaign["Events"] = []
    campaign["Events"].append( event )
    with open( "outbreak.json", "w" ) as camp_file:
        json.dump( campaign, camp_file, sort_keys=True, indent=4 )
    return "outbreak.json"

