from . import schema_to_class as s2c
import json

debug = False

def app( timestep, cases = 1 ):
    """
    So here's the plan. Divide population in two. Let's try male and female for now.
    Group 0 (male) goes to work/school on Day 1, for 4 days, then returns home for 10 days.
    Group 1 (female) goes to work/school on Day 8, for 4 days, then returns home for 10 days.
    Implement this as RASV, CONTACT, on day 5 for group 0 with 10 day duration, and
    RASV, CONTACT, on day 12 for group 0 with 10 day duration.
    Repeat every 14 days.
    """
    campaign = {}
    campaign["Events"] = []

    event = s2c.get_default_campaign_event()
    coordinator = s2c.get_class_with_defaults( "StandardEventCoordinator" )
    if coordinator is None:
        print( "s2c.get_class_with_defaults returned None. Maybe no schema.json was provided." )
        return ""
    event.Event_Coordinator_Config = coordinator
    intervention = s2c.get_class_with_defaults( "RouteAwareSimpleVaccine" )
    intervention.Vaccine_Route = "TRANSMISSIONROUTE_CONTACT"
    coordinator.Intervention_Config = intervention
    coordinator.Target_Demographic = "ExplicitGender"
    coordinator.Target_Gender = "Male"
    coordinator.Timesteps_Between_Repetitions = 14
    coordinator.Number_Repetitions = -1
    waning = s2c.get_class_with_defaults( "WaningEffectBox" )
    waning.Box_Duration = 10
    waning.Initial_Effect = 1.0
    intervention.Waning_Config = waning 
    coordinator.finalize()
    intervention.finalize()
    waning.finalize()

    event.Start_Day = float(timestep+1+4)
    campaign["Events"].append( event )

    event = s2c.get_default_campaign_event()
    coordinator = s2c.get_class_with_defaults( "StandardEventCoordinator" )
    event.Event_Coordinator_Config = coordinator
    intervention = s2c.get_class_with_defaults( "RouteAwareSimpleVaccine" )
    intervention.Vaccine_Route = "TRANSMISSIONROUTE_CONTACT"
    coordinator.Intervention_Config = intervention
    coordinator.Target_Demographic = "ExplicitGender"
    coordinator.Target_Gender = "Female"
    coordinator.Timesteps_Between_Repetitions = 14
    coordinator.Number_Repetitions = -1
    waning = s2c.get_class_with_defaults( "WaningEffectBox" )
    waning.Initial_Effect = 1.0
    waning.Box_Duration = 10
    intervention.Waning_Config = waning 
    coordinator.finalize()
    intervention.finalize()
    waning.finalize()

    event.Start_Day = float(timestep+8+4)
    campaign["Events"].append( event )

    new_camp_filename = "tenfour" 
    if debug:
        new_camp_filename += "_" + str(timestep)
    new_camp_filename += ".json" 
    with open( new_camp_filename, "w" ) as camp_file:
        json.dump( campaign, camp_file, sort_keys=True, indent=4 )

    return new_camp_filename
